// Gunslinger.cpp

#include "Gunslinger.h"
#include <string>
using namespace std;

GunSlinger::GunSlinger(){};

GunSlinger::GunSlinger(string newName){
	name = newName;
}

State GunSlinger::getState() {
	return state;
}

string GunSlinger::getName() {
	return name;
}

void GunSlinger::setState(State newState){
	state = newState;
}

void GunSlinger::shot(){
	setState(dead);
}

void GunSlinger::shoot(){
	setState(shooting);
	target->shot();
}

void GunSlinger::blink(){
	setState(blinking);
}

void GunSlinger::setTarget(GunSlinger* newTarget){
	target = newTarget;
	setState(duel);
}

